---
title: performance.measure()
slug: Web/API/Performance/measure
tags:
  - API
  - Method
  - Reference
  - Web Performance
  - Web Workers
---
<div>{{APIRef("User Timing API")}}</div>

<p>The <strong><code>measure()</code></strong> method creates a named {{domxref("DOMHighResTimeStamp","timestamp")}} in the browser's <em>performance entry buffer</em> between marks, the navigation start time, or the current time. When measuring between two marks, there is a <em>start mark</em> and <em>end mark</em>, respectively. The named timestamp is referred to as a <em>measure</em>.</p>

<p>The <code>measure</code> can be retrieved by one of the {{domxref("Performance")}} interfaces: ({{domxref("Performance.getEntries","getEntries()")}}, {{domxref("Performance.getEntriesByName","getEntriesByName()")}} or {{domxref("Performance.getEntriesByType","getEntriesByType()")}}).</p>

<p>The <code>measure</code>'s {{domxref("PerformanceEntry","performance entry")}} will have the following property values:</p>

<ul>
 <li>{{domxref("PerformanceEntry.entryType","entryType")}} - set to "<code>measure</code>".</li>
 <li>{{domxref("PerformanceEntry.name","name")}} - set to the "<code>name</code>" given when the measure was created.</li>
 <li>{{domxref("PerformanceEntry.startTime","startTime")}} - set to the start mark {{domxref("DOMHighResTimeStamp","timestamp")}}.</li>
 <li>{{domxref("PerformanceEntry.duration","duration")}} - set to a {{domxref("DOMHighResTimeStamp")}} that is the duration of the measure (typically, the end mark timestamp minus the start mark timestamp).</li>
</ul>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>performance</em>.measure(name);
<em>performance</em>.measure(name, startMark);
<em>performance</em>.measure(name, startMark, endMark);
<em>performance</em>.measure(name, undefined, endMark);
</pre>

<h3 id="Arguments">Arguments</h3>

<dl>
 <dt>name</dt>
 <dd>A {{domxref("DOMString")}} representing the name of the measure.</dd>
 <dt>startMark {{optional_inline}}</dt>
 <dd>A {{domxref("DOMString")}} representing the name of the measure's starting mark. May also be the name of a {{domxref("PerformanceTiming")}} property. If it is omitted, then the start time will be the navigation start time.</dd>
 <dt>endMark {{optional_inline}}</dt>
 <dd>A {{domxref("DOMString")}} representing the name of the measure's ending mark. May also be the name of a {{domxref("PerformanceTiming")}} property. If it is omitted, then the current time is used.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<dl>
 <dt>void</dt>
 <dd></dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following example shows how <code>measure()</code> is used to create a new <em>measure</em> {{domxref("PerformanceEntry","performance entry")}} in the browser's performance entry buffer.</p>

<pre class="brush: js">const markerNameA = "example-marker-a"
const markerNameB = "example-marker-b"

// Run some nested timeouts, and create a PerformanceMark for each.
performance.mark(markerNameA);
setTimeout(function() {
  performance.mark(markerNameB);
  setTimeout(function() {

    // Create a variety of measurements.
    performance.measure("measure a to b", markerNameA, markerNameB);
    performance.measure("measure a to now", markerNameA);
    performance.measure("measure from navigation start to b", undefined, markerNameB);
    performance.measure("measure from the start of navigation to now");

    // Pull out all of the measurements.
    console.log(performance.getEntriesByType("measure"));

    // Finally, clean up the entries.
    performance.clearMarks();
    performance.clearMeasures();
  }, 1000);
}, 1000);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('User Timing Level 2', '#dom-performance-measure', 'measure()')}}</td>
   <td>{{Spec2('User Timing Level 2')}}</td>
   <td>Clarifies <code>measure()</code> processing model.</td>
  </tr>
  <tr>
   <td>{{SpecName('User Timing', '#dom-performance-measure', 'measure()')}}</td>
   <td>{{Spec2('User Timing')}}</td>
   <td>Basic definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Performance.measure")}}</p>
</div>
